BeerOverflow.Web/Models/BeerViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Models
{
    public class BeerViewModel
    {
        public Guid Id { get; set; }
        [StringLength(40, MinimumLength = 2, ErrorMessage="Name length not valid")]
        public string Name { get; set; }
        [StringLength(40, MinimumLength = 2, ErrorMessage = "Description length not valid")]
        public string Description { get; set; }
        public string ImageURL { get; set; }
        public double Price { get; set; }
        public string StyleName { get; set; }
        public string BreweryName { get; set; }

        [Range(1, 50, ErrorMessage = "Please enter value between {0} and {1}")]
        public double AlcoholPercent { get; set; }

        [StringLength(40, MinimumLength = 2, ErrorMessage = "Country is a mandatory field")]
        public string CountryName { get; set; }
        public int Mililiters { get; set; }
        public ICollection<ReviewViewModel> Reviews { get; set; }
    }
}

BeerOverflow.Web/Controllers/BeerController.cs
using System;

using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeerOverflow.Services.Services;
using BeerOverflow.Web.Mappers;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;
using BeerOverflow.Services.Contracts;


namespace BeerOverflow.Web.Controllers
{
    public class BeerController : Controller
    {
        private readonly IBeerServices beerService;
        private readonly ICountryServices countryServices;
        private readonly IBreweryServices breweryServices;
        private readonly IStyleServices styleServices;
        public BeerController(IBeerServices beerService, ICountryServices countryServices, IBreweryServices breweryServices, IStyleServices styleServices)
        {
            this.beerService = beerService;
            this.countryServices = countryServices;
            this.breweryServices = breweryServices;
            this.styleServices = styleServices;
        }

        [HttpGet]
        public IActionResult CreateBeer()
        {
            ViewBag.Breweries = breweryServices.GetAllBreweries().MapFrom().ToList();
            ViewBag.Countries = countryServices.GetAllCountries().MapFrom().ToList();
            ViewBag.Styles = styleServices.GetAllStyles().MapFrom().ToList();

            return View();
        }

        [HttpPost]
        public IActionResult CreateBeer(BeerViewModel beerViewModel)
        {
            var beer = beerService.CreateBeer(beerViewModel.MapFrom());

            return RedirectToAction("ListBeers", "Beer");
        }

        [HttpGet]
        public IActionResult ListBeers(BeerSearchModel model,string sortOption)
        {
            var beerList = beerService.GetAllBeers().ToList().MapFrom();

            if (!string.IsNullOrEmpty(model.Searcher)&& !string.IsNullOrEmpty(model.SearchOption))
            {
                var searchOption = model.SearchOption;
                beerList = beerService.Search(beerList.MapFrom(), searchOption, model.Searcher).MapFrom();
               
            }
            if (sortOption != null)
            {
                beerList = beerService.Sort(beerList.MapFrom(),sortOption).MapFrom();
            }
            
            model.Beers = beerList;
            return View(model);
        }

        [HttpGet]
        public IActionResult DeleteBeer()
        {
            return View();
        }

        [HttpPost]
        public IActionResult DeleteBeer(string name)
        {
            beerService.DeleteBeer(name);

            return RedirectToAction("ListBeers", "Beer");
        }

        [HttpGet]
        public IActionResult EditBeer(Guid id)
        {
            return View(beerService.GetBeerDTO(id).MapFrom());
        }

        [HttpPost]
        public IActionResult EditBeer(Guid id, string name)
        {

            this.beerService.EditBeer(id, name);
            return RedirectToAction("ListBeers");
        }
        [HttpGet]
        public IActionResult Details(Guid id)
        {
            var beer = this.beerService.GetBeerDTO(id).MapFrom();
            return View(beer);
        }
        [HttpGet]
        public IActionResult GetBeersOfTheWeek()
        {
            var list = beerService.GetBeersOfTheWeek().MapFrom();
            return View("_List", list);
        }
    }
}

BeerOverflow.Web/Controllers/BreweryController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeerOverflow.Services.Services;
using BeerOverflow.Web.Mappers;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace BeerOverflow.Web.Controllers
{
    public class BreweryController : Controller
    {
        private readonly IBreweryServices breweryServices;
        private readonly ICountryServices countryServices;
        public BreweryController(IBreweryServices breweryServices, ICountryServices countryServices)
        {
            this.breweryServices = breweryServices;
            this.countryServices = countryServices;
        }

        [HttpGet]
        public IActionResult CreateBrewery()
        {
            BreweryViewModel viewModel = new BreweryViewModel();

           // viewModel.Countries 
                ViewBag.Countries = countryServices.GetAllCountries().MapFrom().ToList();

            return View();
        }

        [HttpPost]
        public IActionResult CreateBrewery(BreweryViewModel breweryVM)
        {
            this.breweryServices.CreateBrewery(breweryVM.MapFrom());
            return RedirectToAction("ListBreweries");
        }

        [HttpGet]
        public IActionResult ListBreweries()
        {
            var breweries = this.breweryServices.GetAllBreweries().MapFrom().ToList();
            return View(breweries);
        }

        [HttpGet]
        public IActionResult DeleteBrewery()
        {
            return View();
        }

        [HttpPost]
        public IActionResult DeleteBrewery(string name)
        {
            this.breweryServices.DeleteBrewery(name);

            return RedirectToAction("ListBreweries");
        }

        [HttpGet]
        public IActionResult EditBrewery(Guid id)
        {
            var brewery = this.breweryServices.GetBrewery(id).MapFrom();

            return View(brewery);
        }

        [HttpPost]
        public IActionResult EditBrewery(Guid id, string name)
        {
            breweryServices.EditBrewery(id, name);
            return RedirectToAction("ListBreweries");
        }

        [HttpGet]
        public IActionResult Details(Guid id)
        {
          var brewery = this.breweryServices.GetBrewery(id).MapFrom();
            return View(brewery);
        }
    }
}

BeerOverflow.Web/Controllers/ReviewController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.Services;
using BeerOverflow.Web.Mappers;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;

namespace BeerOverflow.Web.Controllers
{
    public class ReviewController : Controller
    {
        private readonly IReviewServices reviewService;
        private readonly IBeerServices beerService;


        public ReviewController(IReviewServices reviewService, IBeerServices beerService)
        {
            this.reviewService = reviewService;
            this.beerService = beerService;
        }

        [HttpGet]
        public IActionResult CreateReview(Guid id)
        {
            var review = new ReviewViewModel();
            var beer = beerService.GetBeerDTO(id).MapFrom();
            review.BeerName = beer.Name;

            return View(review);
        }

        [HttpPost]
        public IActionResult CreateReview(ReviewViewModel review)
        {
            //var review = this.reviewService.GetReview(id).MapFrom();

            var reviewDTO = reviewService.CreateReview(review.MapFrom());

            Guid beerId = beerService.GetBeerDTO(reviewDTO.BeerName).Id;

            if (review == null || beerId == null)
            {
                throw new ArgumentNullException();
            }

            return RedirectToAction("Details","Beer",new { id = beerId});
        }

        [HttpGet]
        public IActionResult ListAllReviews()
        {
            var reviewList = reviewService.GetAllReviews()
                .ToList()
                .MapFrom();

            return View(reviewList);
        }

        [HttpGet]
        public IActionResult ListAllReviewsForBeer(Guid id)
        {
            var beer = beerService.GetBeerDTO(id);
            var reviewList = reviewService.GetAllReviewsForBeer(beer)
                .ToList()
                .MapFrom();

            return View(reviewList);
        }

        [HttpGet]
        public IActionResult DeleteReview()
        {
            return View();
        }

        [HttpPost]
        public IActionResult DeleteReview(Guid id)
        {
            reviewService.DeleteReview(id);

            return RedirectToAction("ListBeers", "Beer");
        }

        [HttpGet]
        public IActionResult EditReview(Guid id)
        {
            return View();
        }

        [HttpPost]
        public IActionResult UpdateReview(Guid id, string body)
        {
            reviewService.EditReview(id, body);

            return RedirectToAction("ListBeers", "Beer");
        }
    }
}

BeerOverflow.Web/Controllers/StyleController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeerOverflow.Models;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Web.Mappers;
using BeerOverflow.Web.Models;
using Microsoft.AspNetCore.Mvc;

namespace BeerOverflow.Web.Controllers
{
    public class StyleController : Controller
    {
        private readonly IStyleServices service;
        public StyleController(IStyleServices service)
        {
            this.service = service;
        }

        [HttpGet]
        public IActionResult ListStyles(StyleSearchModel model)
        {
            var styleList = service.GetAllStyles().ToList().MapFrom();

            if (!string.IsNullOrEmpty(model.Searcher))
            {
                styleList = styleList
                    .Where(s => s.Name.Contains(model.Searcher))
                    .ToList();
            }

            model.Styles = styleList;
            return View(model);
        }

        [HttpGet]
        public IActionResult CreateStyle()
        {
            return View();
        }

        [HttpPost]
        public IActionResult CreateStyle(StyleViewModel styleViewModel)
        {
            var styleDTO = styleViewModel.MapFrom();

            service.CreateStyle(styleDTO);

            return RedirectToAction("ListStyles");
        }

        [HttpGet]
        public IActionResult DeleteStyle (Guid id)
        {
            service.DeleteStyle(id);


            return RedirectToAction("ListStyles");
        }

        [HttpGet]
        public IActionResult Details(Guid id)
        {
            var style = this.service.GetStyle(id).MapFrom();
            return View(style);
        }


    }
}

BeerOverflow.Web/Views/Beer/CreateBeer.cshtml
@model BeerOverflow.Web.Models.BeerViewModel

@{ 
    var slist = ViewBag.Sdata;
}

<h1 style="color:#b58900">Create a new beer</h1>

<style>
    div {
        background-image:url(background.png);
        
    }
</style>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="CreateBeer">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="ImageURL" class="control-label"></label>
                <input asp-for="ImageURL" class="form-control" />
                <span asp-validation-for="ImageURL" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="AlcoholPercent" class="control-label">Alcohol percent</label>
                <input asp-for="AlcoholPercent" class="form-control" />
                <span asp-validation-for="AlcoholPercent" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Mililiters" class="control-label"></label>
                <input asp-for="Mililiters" class="form-control" />
                <span asp-validation-for="Mililiters" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="StyleName" class="control-label"></label>
                @Html.DropDownListFor(model => model.StyleName, new SelectList(ViewBag.Styles, "Name", "Name"), "")<br>
                Do not see the brewery you need?<a style="color:#b58900" asp-controller="Style" asp-action="CreateStyle"><br>Click to create</a>
            </div>
            <div class="form-group">
                <label asp-for="BreweryName" class="control-label"></label>
                @Html.DropDownListFor(model => model.BreweryName, new SelectList(ViewBag.Breweries, "Name", "Name"), "")<br>
                Do not see the brewery you need? <a style="color:#b58900" asp-controller="Brewery" asp-action="CreateBrewery"><br >Click to create</a> 
            </div>
            <div class="form-group">
                <label asp-for="CountryName" class="control-label"></label>
                @Html.DropDownListFor(model => model.CountryName, new SelectList(ViewBag.Countries, "Name", "Name"), "")<br>
                Do not see the country you need?<a style="color:#b58900" asp-controller="Country" asp-action="CreateCountry"><br style="color:#b58900">Click to create</a>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
                <br />
            </div>
        </form>
    </div>
</div>

<div>
   <a asp-controller="Beer" asp-action="ListBeers">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

BeerOverflow.Web/Views/Beer/DeleteBeer.cshtml
@model BeerOverflow.Web.Models.BeerViewModel

@{
    ViewData["Title"] = "DeleteBeer";
}

<h1 style="color:#b58900" >DeleteBeer</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
  
    <form asp-action="DeleteBeer" >
        <div class="form-group">
            <label asp-for="Name" class="control-label"></label>
            <input asp-for="Name" class="form-control" />
            <span asp-validation-for="Name" class="text-danger"></span>
        </div>
        <input type="submit" value="Delete" class="btn btn-danger" />
        <br />
        <a style="color:#b58900" asp-action="Index">Back to List</a>
    </form>
</div>

BeerOverflow.Web/Views/Beer/Details.cshtml
@model BeerOverflow.Web.Models.BeerViewModel

<h1 style="color:#b58900">@Model.Name</h1>
<br>
<div class="row featurette">
    <div class="col-md-7 order-md-2">
        <p class="lead"><h4 style="color:#b58900">Description: </h4> <h6>@Model.Description</h6></p>
        <p class="lead"><h4 style="color:#b58900">Mililiters: </h4> <h6>@Model.Mililiters </h6></p>
        <p class="lead"><h4 style="color:#b58900">Country origin: </h4> <h6>@Model.CountryName</h6></p>
        <p class="lead"><h4 style="color:#b58900">Style: </h4> <h6>@Model.StyleName</h6></p>
        <p class="lead"><h4 style="color:#b58900">Brewery: </h4> <h6>@Model.BreweryName</h6></p>
        <p class="lead"><h4 style="color:#b58900">Alcohol percent: </h4> <h6>@Model.AlcoholPercent</h6></p>

    </div>
    <div class="col-md-5 order-md-1">
        <img class="rounded-circle" src=@Model.ImageURL alt="Generic placeholder image" width="300" height="300">
    </div>
</div>
<center>
    @if (User.Identity.IsAuthenticated)
    {
        <a class="btn btn-primary" style="color:white" asp-controller="Wishlist" asp-action="AddBeerToUserWishList" asp-route-username="@User.Identity.Name" asp-route-beerId="@Model.Id">Add this beer to my WishList</a>
    }
</center>

<body>
    <br>
    @if (User.Identity.IsAuthenticated)
    {
        <a class="btn" style="color:white" asp-controller="Review" asp-action="CreateReview" asp-route-id="@Model.Id"> Create new review</a>
    }
    <br>
    @foreach (var item in Model.Reviews)
    {
        @Html.TextBox("myTextBox", item.Content, new { @class = "form-control" })
        <br>
        <br>
    }
</body>

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

@{
    double reviewScore = 0;
    int counter = 0;
    int reviewS = 0;
    foreach (var item in Model.Reviews)
    {
        reviewScore += item.Rating;
        counter++;
    }
    reviewS = (int)Math.Round(reviewScore = reviewScore / counter);
    <center>
        <h1>Average Rating</h1>
    </center>
    <style>
        .checked {
            color: orange;
        }
    </style>

    if (reviewS == 1)
    {
        <body>
            <center>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer"></span>
                <span class="fa fa-beer"></span>
                <span class="fa fa-beer"></span>
                <span class="fa fa-beer"></span>
            </center>
        </body>
    }
    if (reviewS == 2)
    {
        <body>
            <center>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer"></span>
                <span class="fa fa-beer"></span>
                <span class="fa fa-beer"></span>
            </center>
        </body>
    }
    if (reviewS == 3)
    {
        <body>
            <center>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer"></span>
                <span class="fa fa-beer"></span>
            </center>
        </body>
    }
    if (reviewS == 4)
    {
        <body>
            <center>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer"></span>
            </center>
        </body>
    }
    if (reviewS == 5)
    {
        <body>
            <center>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
                <span class="fa fa-beer checked"></span>
            </center>
        </body>
    }
    <center style="margin-bottom:50px;">
        <h4>Out of @counter rates.</h4>
    </center>
    <br />
}

BeerOverflow.Web/Views/Beer/EditBeer.cshtml
@model BeerOverflow.Web.Models.BeerViewModel

@{
    ViewData["Title"] = "EditBeer";
}

<h1 style="color:#b58900">EditBeer</h1>

<h4>Changing the name of @Model.Name</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="EditBeer" asp-route-id="@Model.Id">
          
           <input asp-for="Name" class="form-control" />
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="ListBeers">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

BeerOverflow.Web/Views/Beer/ListBeers.cshtml
@model BeerOverflow.Web.Models.BeerSearchModel


@{
    ViewData["Title"] = "ListBeers";
}

<h1 style="color:#b58900">List of all beers in our database</h1>
<br>
@if (User.Identity.IsAuthenticated)
{
    <h5>If you don`t see a beer you like:</h5>
    <p>
        <a style="color:#b58900" asp-controller="Beer" asp-action="CreateBeer">Create New Beer</a>
    </p>
}

<form>
    Select the criteria for the search: <br>
    Name:  @Html.RadioButton("SearchOption", "Name")<br>
    CountryName: @Html.RadioButton("SearchOption", "Country Name")<br>
    BreweryName: @Html.RadioButton("SearchOption", "Brewery Name")<br>
    StyleName: @Html.RadioButton("SearchOption", "Style Name")<br>
    <label asp-for="Searcher">Search keyword:</label>
    <input asp-for="Searcher" />
    <div class="form-group">
        <input type="submit" value="Search" class="btn btn-primary" />
    </div>
</form>

<table class="table table-striped" id="myTable" style="color:white">
    <thead>
        <tr>
            <th>
                Picture
            </th>
            <th>
                <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="NameAsc">NameAsc</a> <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="NameDesc">NameDesc</a>
            </th>
            <th>
                <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="PriceAsc">PriceAsc</a> <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="PriceDesc">PriceDesc</a>
            </th>
            <th>
                StyleName
            </th>
            <th>
                BreweryName
            </th>
            <th>
                <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="AlcoholPercentAsc">AlcoholPercentAsc</a> <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="AlcoholPercentDesc">AlcoholPercentDesc</a>
            </th>
            <th>
                CountryName
            </th>
            <th>
                <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="MililitersAsc">MililitersAsc</a> <a style="color:#b58900" asp-action="ListBeers" asp-route-sortOption="MililitersDesc">MililitersDesc</a>
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model.Beers)
        {
            <tr style="color:white">
                <td>
                    <img class="rounded-circle" src="@item.ImageURL" alt="Generic placeholder image" width="140" height="140">
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Name)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Price)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.StyleName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.BreweryName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.AlcoholPercent)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.CountryName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Mililiters)
                </td>
                @if (User.Identity.IsAuthenticated)
                {
                    <td>
                        <a style="color:#b58900" asp-action="EditBeer" asp-route-id="@item.Id">Edit</a>
                    </td>
                }
                <td>
                    <a style="color:#b58900" asp-action="Details" asp-route-id="@item.Id">Details</a>
                </td>
            </tr>
        }
    </tbody>

</table>